Index: demo/graph_to_eps_demo.cc
===================================================================
--- demo/graph_to_eps_demo.cc	(revision 659)
+++ demo/graph_to_eps_demo.cc	(revision 463)
@@ -183,5 +183,5 @@
   ListDigraph::NodeMap<Point> hcoords(h);
 
-  int cols=int(std::sqrt(double(palette.size())));
+  int cols=int(sqrt(double(palette.size())));
   for(int i=0;i<int(paletteW.size());i++) {
     Node n=h.addNode();
Index: lemon/network_simplex.h
===================================================================
--- lemon/network_simplex.h	(revision 659)
+++ lemon/network_simplex.h	(revision 660)
@@ -382,6 +382,5 @@
         const int MIN_BLOCK_SIZE = 10;
 
-        _block_size = std::max( int(BLOCK_SIZE_FACTOR *
-                                    std::sqrt(double(_arc_num))),
+        _block_size = std::max( int(BLOCK_SIZE_FACTOR * sqrt(_arc_num)),
                                 MIN_BLOCK_SIZE );
       }
@@ -459,6 +458,5 @@
         const int MIN_MINOR_LIMIT = 3;
 
-        _list_length = std::max( int(LIST_LENGTH_FACTOR *
-                                     std::sqrt(double(_arc_num))),
+        _list_length = std::max( int(LIST_LENGTH_FACTOR * sqrt(_arc_num)),
                                  MIN_LIST_LENGTH );
         _minor_limit = std::max( int(MINOR_LIMIT_FACTOR * _list_length),
@@ -580,6 +578,5 @@
         const int MIN_HEAD_LENGTH = 3;
 
-        _block_size = std::max( int(BLOCK_SIZE_FACTOR *
-                                    std::sqrt(double(_arc_num))),
+        _block_size = std::max( int(BLOCK_SIZE_FACTOR * sqrt(_arc_num)),
                                 MIN_BLOCK_SIZE );
         _head_length = std::max( int(HEAD_LENGTH_FACTOR * _block_size),
@@ -1148,4 +1145,5 @@
       // Run Circulation to check if a feasible solution exists
       typedef ConstMap<Arc, Flow> ConstArcMap;
+      ConstArcMap zero_arc_map(0), inf_arc_map(inf_cap);
       FlowNodeMap *csup = NULL;
       bool local_csup = false;
@@ -1168,5 +1166,5 @@
           } else {
             Circulation<GR, FlowArcMap, ConstArcMap, FlowNodeMap>
-              circ(_graph, *_plower, ConstArcMap(inf_cap), *csup);
+              circ(_graph, *_plower, inf_arc_map, *csup);
             circ_result = circ.run();
           }
@@ -1174,9 +1172,9 @@
           if (_pupper) {
             Circulation<GR, ConstArcMap, FlowArcMap, FlowNodeMap>
-              circ(_graph, ConstArcMap(0), *_pupper, *csup);
+              circ(_graph, zero_arc_map, *_pupper, *csup);
             circ_result = circ.run();
           } else {
             Circulation<GR, ConstArcMap, ConstArcMap, FlowNodeMap>
-              circ(_graph, ConstArcMap(0), ConstArcMap(inf_cap), *csup);
+              circ(_graph, zero_arc_map, inf_arc_map, *csup);
             circ_result = circ.run();
           }
@@ -1195,5 +1193,5 @@
           } else {
             Circulation<RevGraph, FlowArcMap, ConstArcMap, NegNodeMap>
-              circ(rgraph, *_plower, ConstArcMap(inf_cap), neg_csup);
+              circ(rgraph, *_plower, inf_arc_map, neg_csup);
             circ_result = circ.run();
           }
@@ -1201,9 +1199,9 @@
           if (_pupper) {
             Circulation<RevGraph, ConstArcMap, FlowArcMap, NegNodeMap>
-              circ(rgraph, ConstArcMap(0), *_pupper, neg_csup);
+              circ(rgraph, zero_arc_map, *_pupper, neg_csup);
             circ_result = circ.run();
           } else {
             Circulation<RevGraph, ConstArcMap, ConstArcMap, NegNodeMap>
-              circ(rgraph, ConstArcMap(0), ConstArcMap(inf_cap), neg_csup);
+              circ(rgraph, zero_arc_map, inf_arc_map, neg_csup);
             circ_result = circ.run();
           }
@@ -1229,5 +1227,5 @@
 
       // Store the arcs in a mixed order
-      int k = std::max(int(std::sqrt(double(_arc_num))), 10);
+      int k = std::max(int(sqrt(_arc_num)), 10);
       int i = 0;
       for (ArcIt e(_graph); e != INVALID; ++e) {
Index: tools/lgf-gen.cc
===================================================================
--- tools/lgf-gen.cc	(revision 659)
+++ tools/lgf-gen.cc	(revision 631)
@@ -66,5 +66,5 @@
   double tlen=0;
   for(EdgeIt e(g);e!=INVALID;++e)
-    tlen+=std::sqrt((coords[g.v(e)]-coords[g.u(e)]).normSquare());
+    tlen+=sqrt((coords[g.v(e)]-coords[g.u(e)]).normSquare());
   return tlen;
 }
@@ -189,5 +189,5 @@
       (r.x * r.x + r.y * r.y) * (p.x * q.y - q.x * p.y);
 
-    return d / (2 * a) + std::sqrt((d * d + e * e) / (4 * a * a) + f / a);
+    return d / (2 * a) + sqrt((d * d + e * e) / (4 * a * a) + f / a);
   }
 
@@ -207,5 +207,5 @@
     double b = (q.x - sx) * p.y - (p.x - sx) * q.y;
     double d = (q.x - sx) * (p.x - sx) * (p - q).normSquare();
-    return (b - std::sqrt(d)) / a;
+    return (b - sqrt(d)) / a;
   }
 
@@ -814,5 +814,5 @@
   double tlen=0;
   for(EdgeIt e(g);e!=INVALID;++e)
-    tlen+=std::sqrt((coords[g.v(e)]-coords[g.u(e)]).normSquare());
+    tlen+=sqrt((coords[g.v(e)]-coords[g.u(e)]).normSquare());
   std::cout << "Total arc length  : " << tlen << std::endl;
 